//
//  Onigiri.h
//  onitest
//
//  Created by dev on 10/05/12.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "oniguruma.h"


enum ONIGIRI_RESULT 
{
	ONIGIRI_ERROR = 0,
	ONIGIRI_SUCCESS = 1
};



@interface OnigiriRange : NSObject
{
@public
	int begin;
	int end; //end-1がヒットした文字列の終端
}

@property(readonly) int begin, end;

@end





@interface Onigiri : NSObject 
{
	NSString *lastError;
}

-(id)init;
-(void)dealloc;

//posListはOnigiriRangeの配列
//このメソッド内でメモリ確保している。
//autoreleaseずみ
-(int)search:(NSString *)str pattern:(NSString *)pat result:(NSMutableArray **)posList;
-(NSString *)getLastError;



//これは呼び出さないこと。呼んでもいいけど。
-(void *)private_dlsymWrap:(char *)symbol;

@end

unsigned char charLength[256];
#define UTF8STEP(p) ((p) + charLength[*(unsigned char *)(p)])

