//
//  main.m
//  onitest
//
//  Created by dev on 10/05/11.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <wchar.h>
#import <xlocale.h>
#import <Cocoa/Cocoa.h>
#import "Onigiri.h"

#define UTF8_CHAR_MAXLENGTH 6

int main(int argc, char *argv[])
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	NSBundle *mainBundle = [NSBundle mainBundle];
	NSString *resourcePath = [mainBundle resourcePath];
	NSString *stringPath = [resourcePath stringByAppendingPathComponent:@"teststring.txt"];

	NSString *str = [NSString stringWithContentsOfFile:stringPath];
	NSString *pat = @"やっぱマクロでやった方が速いっすねー";
	
	NSMutableArray *posList = nil;
	Onigiri *onigiri = [[Onigiri alloc] init];
	[onigiri search:str pattern:pat result:&posList];
	
	OnigiriRange *range = [posList objectAtIndex:0];
	char *start = [str UTF8String];
	char *p = start;
	int count = 1;

    NSDate *startTime = [NSDate date];

/*
    int result = 0;
	locale_t l = newlocale(LC_ALL_MASK, "ja_JP.UTF-8", NULL);
	while(p < (start + range.begin))
	{
		if((result = mblen_l(p, UTF8_CHAR_MAXLENGTH, l)) < 0)
		{
			NSString *now = [NSString stringWithUTF8String:p];
			NSLog(now);
		}
		p += result;
		count++;
	}
*/		

	while(p < start + range.begin)
	{
		p = UTF8STEP(p);
		count++;
	}

	NSTimeInterval interval = [startTime timeIntervalSinceNow];
	NSLog([NSString stringWithFormat:@"Elapsed time: %f   count: %d", -interval, count]);

	[pool release];
	return NSApplicationMain(argc,  (const char **) argv);
}

